poj3126 Prime Path (广搜) 题解

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 15238 Accepted: 8575

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0

Source

Northwestern Europe 2006


题目大意: 给定组数n,每组输入两个四位数的质数(也叫素数),问左边的质数最少经过可以几次变化可以变成后边质数?  关键点来了::怎么变呢?? 是这样的:左边的质数每次只能更改个,十,百,千位上的一个,且每次更改完的新数字还必须是质数,比如上面说的 从1033---->8179  可以这样变:1033-->1733-->3733-->3739-->3779-->8779-->8179,这样就是经过了六次变动,且每次变动完的数字都是质数。。到这里你应该能想到每个位上的数字在一次变动中可能变大,也可能变小,,所以嘛~come  on !上广搜! 。。。。还有不要忘记判质数啊!!  我的代码虽有点多,但灰常容易理解,不信请看得意

上代码:
#include <iostream>
#include<queue>
#include<string.h>
#include<cmath>
using namespace std;
int m,n,flag;
int step[11000],vis[10010],path[10010];
int check(int x)
{
    int i;
    for(i=2; i<=int(sqrt(double(x))); i++)
    {
         if(x%i==0)
            return 0;
    }
    return 1;
}
void bfs(int x)
{
    int s,i,j;
    memset(step,0,sizeof(step));
    memset(vis,0,sizeof(vis));
    queue<int>q;
    while(!q.empty())
        q.pop();
    q.push(x);
    while(!q.empty())
    {
        x=q.front();
        q.pop();
        if(x==n)
        {
            flag=1;
            return;
        }
        int a=x/1000;
        int b=(x-a*1000)/100;
        int c=(x-a*1000-b*100)/10;
        int d=x-a*1000-b*100-c*10;
        for(i=0; i<8; i++)
        {
            if(i==0)
            {
                for(j=1; j<10; j++)
                {
                    if(a+j<10)
                    {
                        s=(a+j)*1000+b*100+c*10+d;
                    }
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==1)
            {
                for(j=1; j<10; j++)
                {
                    if(b+j<10)
                        s=a*1000+(b+j)*100+c*10+d;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                        path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==2)
            {
                for(j=1; j<10; j++)
                {
                    if(b-j>=0)
                        s=a*1000+(b-j)*100+c*10+d;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==3)
            {
                for(j=1; j<10; j++)
                {
                    if(c+j<10)
                        s=a*1000+b*100+(c+j)*10+d;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==4)
            {
                for(j=1; j<10; j++)
                {
                    if(c-j>=0)
                        s=a*1000+b*100+(c-j)*10+d;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==5)
            {
                for(j=1; j<10; j++)
                {
                    if(d+j<10)
                        s=a*1000+b*100+c*10+d+j;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==6)
            {
                for(j=1; j<10; j++)
                {
                    if(d-j>=0)
                        s=a*1000+b*100+c*10+d-j;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
            if(i==7)
            {
                for(j=1; j<10; j++)
                {
                    if(a-j>0)
                        s=(a-j)*1000+b*100+c*10+d;
                    if(check(s)&&!vis[s])
                    {
                        vis[s]=1;
                        step[s]=step[x]+1;
                         path[s]=x;
                        q.push(s);
                    }
                }
            }
        }
    }
}
int main()
{
    int T,i,j;
    cin>>T;
    while(T--)
    {
        flag=0;
        cin>>m>>n;
        bfs(m);
        if(flag==1)
        {
            cout<<step[n]<<endl;
        }

        else cout<<"Impossible"<<endl;
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值